function [output, pocetchyb] = prenosovykanal(vystupkoder,ebN0,n,k,m,bch)

c=vystupkoder;
ebn0=ebN0;

c1 = double(c.x);
if bch==0                     % % % % % % % % % % % % % % % PRO RS kody
c1 = de2bi(c1,m,'left-msb');  % % % % % % % % % % % % % % % prevod z integru do binaru
end

c2=pskmod(c1,2);              % % % % % % % % % % % % % % % BPSK modulace

r=awgn(c2,ebn0);              % % % % % % % % % % % % % % % AWGN kanal (prida AWGN sum)

r=pskdemod(r,2);              % % % % % % % % % % % % % % % BPSK demodulace


if bch==0                     % % % % % % % % % % % % % % % PRO RS kody
a=vec2mat(r,m);
r2 = bi2de(a,'left-msb');     % % % % % % % % % % % % % % % prevod zpet do integru
output=r2';
pocetchyb = length(find(a ~= c1));

else                          % % % % % % % % % % % % % % % PRO BCH kody
output=r; 
pocetchyb = length(find(output ~= c1));
end